// Michael J. Wilson
// Music 256b Winter 2011
// Homework #3

#include "ControlParameter.h"
#include "SaxMax.h"

// Translate from enum to STK parameter
int ControlParameter::get_parameter_from_enum(int parameter)
{
	int result = -1;
	switch (parameter)
	{
		case REED_STIFFNESS:
			result = 2;
			break;
		case REED_APETURE:
			result = 26;
			break;
		case NOISE_GAIN:
			result = 4;
			break;
		case BLOW_POSITION:
			result = 11;
			break;
		case VIBRATO_FREQUENCY:
			result = 29;
			break;
		case VIBRATO_GAIN:
			result = 1;
			break;
		case BREATH_PRESSURE:
			result = 128;
			break;
		default:
			result = -1;
			break;
	};
	return result;
}

void ControlParameter::slew()
{
	const float threshold = .000001;
	float difference = target - value;
	if(abs(difference) < threshold)
	{
		value = target;
	}
	else
	{
		value += (slew_rate * difference);
	}
}
